
(* name.ML *)

(* gives theorems appropriate names which could be used as input *)

infix 0 RS RSN RL RLN MRS MRL COMP;

(* name_of_thm : thm -> string, gives name of a theorem *)
fun name_of_thm th = 
  let val {der = Join (hod, _), ...} = rep_thm th
    fun nd (Theorem name) = name
      | nd (Axiom (_, name)) = name
      | nd _ = ""
  in nd hod end ;

structure no_name = 
struct
val (op RS) = (op RS) ;
val (op MRS) = (op MRS) ;
val tn = tn ;
val tnr = tnr ;
val md1 = md1 ;
val md2 = md2 ;
val symmetric = symmetric ;
val reflexive_thm = reflexive_thm ;
end ;

structure name = 
struct
fun th1 RS th2 = name_thm
  ("(" ^ name_of_thm th1 ^ " RS " ^ name_of_thm th2 ^ ")",
  no_name.RS (th1, th2)) ;
fun md1 th = name_thm ("(md1 " ^ name_of_thm th ^ ")", no_name.md1 th) ;
fun md2 th = name_thm ("(md2 " ^ name_of_thm th ^ ")", no_name.md2 th) ;
fun nthl thl = "[" ^ implode (separate ", " (map name_of_thm thl)) ^ "]" ;
fun thl MRS th = name_thm (
    "(" ^ nthl thl ^ " MRS " ^ name_of_thm th ^ ")", no_name.MRS (thl, th)) ;
fun tn thl = name_thm ("(tn " ^ nthl thl ^ ")", no_name.tn thl) ;
fun tnr thl = name_thm ("(tnr " ^ nthl thl ^ ")", no_name.tnr thl) ;
fun symmetric th = 
    name_thm ("(symmetric " ^ name_of_thm th ^ ")", no_name.symmetric th) ;
val reflexive_thm = name_thm ("reflexive_thm", no_name.reflexive_thm) ;
end ;
